;========]  dos.library offsets      [==============================
Open		equ	-$001E	(name,accessMode)(D1/D2)
Close		equ	-$0024	(file)(D1)
Read		equ	-$002A	(file,buffer,length)(D1/D2/D3)
Write		equ	-$0030	(file,buffer,length)(D1/D2/D3)
Output		equ	-$003C	()

;========]  exec.library offsets      [=============================
Forbid		equ	-$0084	()
Permit		equ	-$008A	()
CloseLibrary	equ	-$019E	(library)(A1)
OpenLibrary	equ	-$0228	(libName,version)(A1,D0)

;========]  graphics.library offsets  [=============================
ClearScreen	equ	-$0030	(rastPort)(A1)
SetFont		equ	-$0042	(RastPortID,textFont)(A1,A0)
ScrollRaster	equ	-$018C	(rastPort,dX,dY,minx,miny,maxx,maxy)(A1,D0/D1/D2/D3/D4/D5)
FreeSprite	equ	-$019E	(num)(d0)

;=======] intuition.library offsets   [=============================
CloseScreen	equ	-$0042	(Screen)(A0)
CloseWindow	equ	-$0048	(Window)(A0)
DisplayAlert	equ	-$005A	(AlertNumber,String,Height)(D0/A0,D1)
OpenScreen	equ	-$00C6	(OSargs)(A0)
OpenWindow	equ	-$00CC	(OWargs)(A0)
PrintIText	equ	-$00D8	(rp,itext,left,top)(A0/A1,D0/D1)

;=======] diskfont.library offsets    [=============================
OpenDiskFont	equ	-$001E	(textAttr)(A0)


  ;===============================================================; 
  ; Macro fucntions used in Code                                  ; 
  ;===============================================================;          	

CALLDiskfont	macro
		move.l		_DiskfontBase,a6
		jsr		\1(a6)
		endm
		
CALLDOS		macro
		move.l		_DOSBase,a6
		jsr		\1(a6)
		endm

CALLEXEC	macro
		move.l		(_SysBase),a6
		jsr		\1(a6)
		endm

CALLGRAF	macro
		move.l		_GfxBase,a6
		jsr		\1(a6)
		endm
		
		
CALLINT		macro
		move.l		_IntuitionBase,a6
		jsr		\1(a6)
		endm
		

OPENDiskfont	macro
		lea		Diskfontname,a1
		moveq.l		#0,d0
		CALLEXEC	OpenLibrary
		move.l		d0,_DiskfontBase
		endm

OPENDOS		macro
		lea		dosname,a1
		moveq.l		#0,d0
		CALLEXEC	OpenLibrary
		move.l		d0,_DOSBase
		endm
OPENGRAPHICS	macro
		lea		gfxname,a1
		moveq.l		#0,d0
		CALLEXEC	OpenLibrary
		move.l		d0,_GfxBase
		endm
OPENINTUITION	macro
		lea		intname,a1
		moveq.l		#0,d0
		CALLEXEC	OpenLibrary
		move.l		d0,_IntuitionBase
		endm

CLOSEDiskfont	macro
		move.l		_DiskfontBase,a1
		CALLEXEC	CloseLibrary
		endm

CLOSEDOS	macro
		move.l		_DOSBase,a1
		CALLEXEC	CloseLibrary	
		endm

CLOSEGRAPHICS	macro
		move.l		_GfxBase,a1
		CALLEXEC	CloseLibrary	
		endm
		
		
CLOSEINTUITION	macro
		move.l		_IntuitionBase,a1
		CALLEXEC	CloseLibrary	
		endm
		
		
		
LIBNAMES	macro
Diskfontname	dc.b		'diskfont.library',0
		even
_DiskfontBase	dc.l		0
dosname		dc.b		'dos.library',0
		even
_DOSBase	dc.l		0
gfxname		dc.b		'graphics.library',0
		even
_GfxBase	dc.l		0
intname		dc.b		'intuition.library',0
		even
_IntuitionBase	dc.l		0
		endm
		
